/***************************************************************************
 *     Copyright 2001  Broadcom Corporation
 *     All Rights Reserved
 *     No portions of this material may be reproduced in any form without the
 *     written permission of:
 *              Broadcom Corporation
 *              16251 Laguna Canyon Road
 *              Irvine, California  92618
 *     All information contained in this document is Broadcom Corporation
 *     company private, proprietary, and trade secret.
 *
 ****************************************************************************
 *
 *     Filename:  timeTable.c
 *     Creation Date: 30 October 2001 (v0.00)
 *     VSS Info:
 *         $Revision: 1.10 $
 *         $Date: 2005/08/15 15:01:37 $
 *
 ****************************************************************************
 *     Description:
 *
 *       Implementation of MTA Kerberos client library
 *
 *     Notes:
 *
 ****************************************************************************/

#include <hausenv.h>
#include <string.h>
#include <stdio.h>
///#include <xbcmos.h>      
#include <hausenv.h>
#include <krb5client.h>
#include <SecLib.h>
//#include <SigSec.h>     /* Signalling Security dependencies - IPSEC */
#include "seckrb.h"
//#include "krbbuf.h"
#include "timeTable.h"
#include "subkeyStore.h"
#include "krb5_err.h"

#include "KerbStatus.h"

/* EN: Define this as 1 when everything is fully compliant!!! */
#define  SEC_PC_COMPLIANT  0

int ktracelevel = 0;    // debug trace messages


/* Saved service provider name from subjectName of service provider certificate */
static char Prov_Service_Provider_Name[256];

static   char mtaFQDN[MAX_STR_LEN];
static   char mtaMac[MAX_STR_LEN];
static   char krbServiceName[MAX_STR_LEN];
static   char krbServiceRealm[MAX_STR_LEN];
static   char krbProvServFQDN[MAX_STR_LEN];
static   char srvc_ip_addr[MAX_STR_LEN];
static   char tgs_ip_addr[MAX_STR_LEN];

extern void Init_prng(void);
extern void krbParseLibInit(int prtFlag);
extern void Init_secCrypto(void);
extern void Init_secCert(void);
extern void prfGetSecInfoBlock(SEC_PROV_INFO_BLOCK *secProvInfoBlock);

#define DEMO 1
extern void DumpAuthBlock(char * msg, KRBCLI_AUTH_BLOCK *authBlock);

/* defentions for pointers to be assigned differently in case of
 * windows and psos. For windows, these pointers need to be assigned
 * after loading the DLL and finding the addresses. For psos, they
 * are simply the address of functions
 * */
typedef unsigned long (* _pkrbSecCryptoDeriveIPSecKey)
(unsigned char *,
 unsigned long,
 const unsigned char *,
 unsigned long,
 unsigned char *,
 unsigned char *,
 unsigned char *,
 unsigned char *,
 int,
 int);
_pkrbSecCryptoDeriveIPSecKey pkrbSecCryptoDeriveIPSecKey;

typedef unsigned long (* _pkrbSecCryptoDeriveSNMPv3Key)
(unsigned char *,
 unsigned long,
 const unsigned char  *,
 unsigned long,
 unsigned char *,
 int  auth_tid,
 unsigned char *,
 int);
_pkrbSecCryptoDeriveSNMPv3Key pkrbSecCryptoDeriveSNMPv3Key;

/*
#ifdef DEMO
static const unsigned char mta_dev_cert[] = {
//#include "MtaDevCert.txt"
#include "./certs/PsDevCert.txt"
};

static const unsigned char mta_man_cert[] = {
//#include "MtaManCert.txt"
#include "./certs/ManCaCert.txt"
};

static const unsigned char tel_root_cert[] = {
//#include "TelRootCert.txt"
//#include "./certs/ManRootCaCert.txt"
#include "./certs/SrvProvRootCaCert.txt"
};

static const unsigned char rsa_priv_exp[] = {
//#include "MtaDevPrivExp.txt"
#include "./certs/PsDevPrivExp.txt"
};

static const unsigned char rsa_mod[] = {
//#include "MtaDevKeyMod.txt"
#include "./certs/PsDevKeyMod.txt"
};
#endif
*/

//#ifdef WIN32
//int alopa_fopened_once = 0;
//#endif

//#ifdef WIN32
//#if 1
//   FILE *alopa_subkey_bin;
//#endif
//#endif

int gMaxRetries = 3;
int gTimeout    = 10;

void kSetMaxRetries(int maxretries)
{
    gMaxRetries = maxretries;
}
void kSetTimeout(int timeout)
{
    timeout = timeout/1000; //change ms to sec
    if ( (timeout > 30) || (timeout < 1) )
    {
        LIBDEBUG("Trying to set Timeout to %d - override and force it to 5\n",timeout);
        timeout = 5;
    }
    gTimeout = timeout;
}

/*
 *****************************************************************************
 ** FUNCTION:     secLibInit
 **
 ** PURPOSE:      Assign proper pointers to functions, for win and psos
 **
 ** PARAMETERS:
 **
 ** RETURNS:
 **
 ** NOTE:
 **
 **
 *****************************************************************************
 */
void secLibInit(void)
{
    /*Initialize global variables in security */

    Init_prng();
    krbParseLibInit(0);
    Init_secCrypto();
    Init_secCert();


#if 0
#ifdef DEMO
    HINSTANCE hSecLibDLL = 0;

    Load_SecLibDLL(&hSecLibDLL);
#else
    pkrbSecCryptoDeriveIPSecKey = &secCryptoDeriveIPSecKey;
    pkrbSecCryptoDeriveSNMPv3Key = &secCryptoDeriveSNMPv3Key;
#endif
#endif

    //pkrbSecCryptoDeriveIPSecKey = &secCryptoDeriveIPSecKey;
    pkrbSecCryptoDeriveSNMPv3Key = SecLibGetCryptoIface()->secCryptoDeriveSNMPv3Key;
}

/*
 *****************************************************************************
 ** FUNCTION:     outputProvAsdRep
 **
 ** PURPOSE:      output the ASD AP Rep from provisioning
 **
 ** PARAMETERS:   apRepAsd - in - ASD pointer
 **
 ** RETURNS:      none
 **
 ** NOTE:
 **
 **
 *****************************************************************************
 */
static void outputProvAsdRep(PROV_ASD_APREP *apRepAsd)
{
    DumpProvAsdApRep("", apRepAsd);

//   int i, idLen, nameLen;
//
//   idLen = (int) apRepAsd->engIdLen;
//   nameLen = (int) apRepAsd->userNameLen;
//
//   /* snmpEngineId */
//   printf("snmpEngineId Length is %i\r\n", idLen);
//   printf("snmpEngineId is ");
//   for (i=0; i<idLen; i++)
//      printf("%c", apRepAsd->engId[i]);
//
//   /* snmpEngine Boots and Time */
//   printf("\r\nsnmpEngineBoots is %i\r\n", apRepAsd->engBoots);
//   printf("snmpEngineTime is %i\r\n", apRepAsd->engTime);
//
//   /* UsmUsername */
//   printf("UsmUsername Length is %i\r\n", nameLen);
//   printf("UsmUsername is ");
//   for (i=0; i<nameLen; i++)
//      printf("%c", apRepAsd->userName[i]);
//   printf("\r\n");
}


/*
 ******************************************************************************
 ** FUNCTION:   printSNMPv3Keys
 **
 ** PURPOSE:    print snmp v3 keys
 **
 ** PARAMETERS:
 **
 ** RETURNS:    nothing
 **
 ** NOTE:
 **
 ******************************************************************************
 */
void printSNMPv3Keys(
                    int             auth_tid,
                    unsigned char   *snmpv3_authkey,
                    int             enc_tid,
                    unsigned char   *snmpv3_enckey)
{
    int i;

    printf("Derived keys for SNMPv3:.\n");
    if ( auth_tid == SNMPV3_HMAC_SHA1_TID )
    {
        printf("authentication (SHA1): ");
        for ( i=0;i<SNMPV3_HMAC_SHA1_SIZE;i++ )
            printf("%x ",snmpv3_authkey[i]);
        printf("\n");
    }
    else if ( auth_tid == SNMPV3_HMAC_MD5_TID )
    {
        printf("authentication (MD5): ");
        for ( i=0;i<SNMPV3_HMAC_MD5_SIZE;i++ )
            printf("%x ",snmpv3_authkey[i]);
        printf("\n");
    }
    if ( enc_tid == SNMPV3_DES_TID )
    {
        printf("encryption (DES): ");
        for ( i=0;i<SNMPV3_DES_KEY_SIZE;i++ )
            printf("%x ", snmpv3_enckey[i]);
        printf("\n");
    }
    else if ( enc_tid == SNMPV3_NULL_TID )
    {
        printf("encryption (NULL) ");
        printf("\n");
    }
}


/*
 ******************************************************************************
 ** FUNCTION:   copySNMPv3Keys
 **
 ** PURPOSE:    copy keys into given structure
 **
 ** PARAMETERS:
 **
 ** RETURNS:    nothing
 **
 ** NOTE:
 **
 ******************************************************************************
 */
void copySNMPv3Keys(
                   int                auth_tid,
                   unsigned char      *snmpv3_authkey,
                   int                enc_tid,
                   unsigned char      *snmpv3_enckey,
                   PROV_CLIENT_KEYS   *prov_key)
{

    if ( auth_tid == SNMPV3_HMAC_SHA1_TID )
    {
        memcpy(prov_key->provAuthKey.key, snmpv3_authkey, SNMPV3_HMAC_SHA1_SIZE);
        prov_key->provAuthKey.tid = SNMPV3_HMAC_SHA1_TID;
    }
    else if ( auth_tid == SNMPV3_HMAC_MD5_TID )
    {
        memcpy(prov_key->provAuthKey.key, snmpv3_authkey, SNMPV3_HMAC_MD5_SIZE);
        prov_key->provAuthKey.tid = SNMPV3_HMAC_MD5_TID;
    }
    else
    {
        LIBDEBUG("ERROR: BAD AUTH TID for SNMPV3 %d\n", auth_tid);
    }

    if ( enc_tid == SNMPV3_DES_TID )
    {
        memcpy(prov_key->provEncrKey.key, snmpv3_enckey, SNMPV3_DES_KEY_SIZE);
        prov_key->provEncrKey.tid = SNMPV3_DES_TID;
    }
    else if ( enc_tid == SNMPV3_NULL_TID )
    {
        prov_key->provEncrKey.key[0] = '\0';
        prov_key->provEncrKey.tid = SNMPV3_NULL_TID;
    }
    else
    {
        LIBDEBUG("ERROR: BAD ENC TID for SNMPV3 %d\n", enc_tid);
    }
}
/////////////////////////////////////
/*
******************************************************************************
** FUNCTION:   StartASRequest
**
** PURPOSE:    Authenticates the Krb5 CLient Request: AS_REQ/REP, AP_REQ/REP
**
** PARAMETERS:
**             pKrbCliAuthBlock - pointer to KrbClient Authentication Block
**             pASDReq - prov or CMS ASD
**             pASDRep - prov or CMS ASD reply
**             pClientKeys - resulting keys
**
** RETURNS:    Success (0) or error code (<> 0)
**
** NOTE:
**
******************************************************************************
*/                  
KERB_STATUS  kStartASRequest(KRBCLI_AUTH_BLOCK  *pKrbCliAuthBlock, MtaCredentials *credentials )
{
    int                  krbto=10;
    krb5_error_code      retval;
    krb5_error_code      rvalue;
    int                  server_nonce;
    int                  auth_tid;
    int                  enc_tid;

    LIBDEBUG("StartASRequest - start\n");

    if ( !pKrbCliAuthBlock )
    {
        LOG(("ERROR: StartASRequest() - NULL Pointer in parameter(s).\n"));
        return KERB_GEN_ERROR;
    }

    if ( ktracelevel > KTRACE_INFO )
        DumpAuthBlock( "start of StartASRequest",pKrbCliAuthBlock);

    secLibInit();

    //if ( (nonVolKrbFlag == 0x0) || (nonVolKrbFlag == 0x01) || (nonVolKrbFlag == 0x03) )
    //{
    //    strcpy(mtaMac, pKrbCliAuthBlock->szMtaMac);
    //    strcpy(mtaFQDN, pKrbCliAuthBlock->szMtaFQDN);
    //    strcpy(krbServiceRealm, pKrbCliAuthBlock->szKrbServiceRealm);
    strcpy(krbServiceName, pKrbCliAuthBlock->szServiceName);
    //    strcpy(krbProvServFQDN, pKrbCliAuthBlock->szProvServerFQDN);
    //    strcpy(tgs_ip_addr, pKrbCliAuthBlock->szKdcIpAddress);
    server_nonce = pKrbCliAuthBlock->serverNonce;
    strcpy(srvc_ip_addr, pKrbCliAuthBlock->szServiceIpAddress);
    //    reason = pKrbCliAuthBlock->krbReason;

    //We are calling into the app here
    if ( secKrbSetCert_ch() )
    {
        LOG(("ERROR: secKrbSetCert_ch failed to read certificates/keys from NVRAM."));
        return 1;
    }

    //}

    if ( pKrbCliAuthBlock->serviceType == APPLICATION_PROV )
    {
        /* Send AS_REQ, process AS_REP results into &credentials */
        LIBDEBUG("INFO: sec Krb5ClientAuthenticate() -- Sending AS-REQ/REP...");
        //trc- should be able to put mtaMac in mtaFQDN here and have no problem.
        retval = secGetKrbCredentials(pKrbCliAuthBlock->szMtaMac,         //mtaMac,
                                      pKrbCliAuthBlock->szKdcIpAddress,   //tgs_ip_addr,
                                      pKrbCliAuthBlock->serviceType,
                                      pKrbCliAuthBlock->szServiceName,    //krbServiceName,
                                      pKrbCliAuthBlock->szKrbServiceRealm,
                                      pKrbCliAuthBlock->szProvServerFQDN, //krbProvServFQDN,
                                      krbto,
                                      pKrbCliAuthBlock->krbReason,        //reason,
                                      credentials);
        //printf(".K - secKrb5ClientAuthenticate: returned from secGetKrbCredentials with (%d)\n",retval);

        if ( retval == KDC_ERR_NONE )
            return KERB_NO_ERROR;
        else
            return KERB_GEN_ERROR;

#if 0
        if ( ! retval )
        {
            LOG(("INFO: StartASRequest() - AS-REQ/REP is OK!"));
            //AppReportKerbStatusCallback(0);//kKerberosASExchangeSuccessful);

            /* if MTA kerberos app, we can't access the mibs */
            if ( reason != KRB_TEST_APPLICATION )
            {
                if ( ( reason == KRB_BOOTUP ) ||
                     ( reason == KRB_TICKET_EXPIRED) || 
                     ( reason == KRB_BADKEYVER_ERROR) )
                {
                    /* Store to keep track of the expiry */
                    if ( pKrbCliAuthBlock->serviceType == APPLICATION_PROV )
                        secStoreToTimeTable(AS_PROV_FLAG, krbServiceName, krbServiceRealm,
                                            &credentials, &app_key);
                    else
                        secStoreToTimeTable(AS_CMS_FLAG, krbServiceName, krbServiceRealm,
                                            &credentials, &app_key);
                }
            }

            if ( reason == KRB_TICKET_EXPIRED )
            {
                LOG(("StartASRequest() - Ticket Renewed Successfully."));
                secFreeCredsAndAppkey(&credentials, &app_key);
                return retval;
            }
            if ( reason == KRB_BADKEYVER_ERROR )
            {
                LOG(("StartASRequest() - Ticket Granted Successfully for BADKEYVER error."));
            }
            //LOG(("INFO: StartASRequest() - Sending AP-REQ/REP ..."));
            if ( reason == KRB_REKEY )
            {
                auth_tid = pKrbCliAuthBlock->rekeyInfoBlock.authTID;
                enc_tid = pKrbCliAuthBlock->rekeyInfoBlock.encTID;
            }
            else
            {
                auth_tid = 0;
                enc_tid = 0;
            }
        }
#endif

    }
    return 0;
}

/*
 ******************************************************************************
 ** FUNCTION:   kStartAPRequest
 **
 ** PURPOSE:    Authenticates the Krb5 CLient Request: AS_REQ/REP, AP_REQ/REP
 **
 ** PARAMETERS:
 **             pKrbCliAuthBlock - pointer to KrbClient Authentication Block
 **             pASDReq - prov or CMS ASD
 **             pASDRep - prov or CMS ASD reply
 **             pClientKeys - resulting keys
 **
 ** RETURNS:    Success (0) or error code (<> 0)
 **
 ** NOTE:
 **
 ******************************************************************************
 */
KERB_STATUS kStartAPRequest(
                           KRBCLI_AUTH_BLOCK    *pKrbCliAuthBlock,
                           void                 *pASDReq,
                           void                 *pASDRep,
                           void                 *pClientKeys,
                           MtaCredentials       *credentials)
{
    //PROV_ASD_APREQ       pProvAsd;
    //PROV_ASD_APREP       pProvAsdRep;
    //PROV_CLIENT_KEYS     provClientKeys;
    int                  krbto=10;
    krb5_error_code      retval;
    krb5_error_code      rvalue;
    int                  auth_tid;
    int                  enc_tid;
    int                  server_nonce;
    MtaApplicationKey    app_key;
    //MtaCredentials       credentials;
    unsigned char        snmpv3_authkey[SNMPV3_HMAC_SHA1_SIZE];
    unsigned char        snmpv3_enckey[SNMPV3_DES_KEY_SIZE];
    KRB_REASON           reason;
    SEC_PROV_INFO_BLOCK  secInfoFuncBlock;
    int                  nonVolKrbFlag;

    //void*  pASDReq = &pProvAsd;
    //void*  pASDRep = &pProvAsdRep;
    //void*  pClientKeys = &provClientKeys;

    LOG((".StartAPRequest - start\n"));

    if ( !pKrbCliAuthBlock )
    {
        LIBDEBUG("ERROR: StartAPRequest() - NULL Pointer in parameter(s).\n");
        return 1;
    }
    //ProvASDReq(pProvAsd);

    if ( ktracelevel > KTRACE_ERROR )
    {
        DumpAuthBlock( "start of StartAPRequest",pKrbCliAuthBlock);
        DumpCredentials("start of StartAPRequest",credentials);
        printf("INFO: StartAPRequest() - Sending AP-REQ/REP ...");
    }
    secLibInit();



    /*   if ( reason == KRB_REKEY )
   {
       auth_tid = pKrbCliAuthBlock->rekeyInfoBlock.authTID;
       enc_tid = pKrbCliAuthBlock->rekeyInfoBlock.encTID;
   }
   else
   {
       auth_tid = 0;
       enc_tid = 0;
   }
  */
    auth_tid = 0;
    enc_tid = 0;
    //none of these params are defined are they global!!!!!!
    /*retval = secGetKrbApplicationKey(mtaMac,
                                     krbServiceName,
                                     srvc_ip_addr,
                                     krbServiceRealm,
                                     krbto,
                                     pKrbCliAuthBlock->serviceType,
                                     server_nonce,
                                     pASDReq,
                                     pASDRep,
                                     credentials,
                                     &app_key,
                                     &auth_tid,
                                     &enc_tid,
                                     reason);
    */

    retval = secGetKrbApplicationKey(pKrbCliAuthBlock->szMtaMac,           //mtaMac,
                                     pKrbCliAuthBlock->szServiceName,      //krbServiceName,
                                     pKrbCliAuthBlock->szServiceIpAddress, //srvc_ip_addr,
                                     pKrbCliAuthBlock->szKrbServiceRealm,  //kbServiceRealm,
                                     krbto,
                                     pKrbCliAuthBlock->serviceType,
                                     pKrbCliAuthBlock->serverNonce,        //server_nonce,
                                     pASDReq,
                                     pASDRep,
                                     credentials,
                                     &app_key,
                                     &auth_tid,
                                     &enc_tid,
                                     pKrbCliAuthBlock->krbReason);         //reason);


    /* analyze return value */
    rvalue = retval + ERROR_TABLE_BASE_krb5;
    switch ( rvalue )
    {
    case KRB5KRB_AP_ERR_BADKEYVER:
        if ( pKrbCliAuthBlock->serviceType == APPLICATION_CMS )
        {
            LOG(("ERROR: sec Krb5ClientAuthenticate() - BAD KEY VERSION ERROR."));
            return rvalue;
        }
        break;
    default:
        break;       
    }

    /* if this is a response to a rekey, get the necessary info
     * from the rekey message.
     */
    if ( reason == KRB_REKEY )
    {
        auth_tid = pKrbCliAuthBlock->rekeyInfoBlock.authTID;
        enc_tid = pKrbCliAuthBlock->rekeyInfoBlock.encTID;
        app_key.sec_params_lifetime = pKrbCliAuthBlock->rekeyInfoBlock.secParamLifeTime;
        app_key.grace_period = pKrbCliAuthBlock->rekeyInfoBlock.gracePeriod;
    }

    LIBDEBUG("WE have a secGetKrbApplicationKey retval = <%d> \n",retval);

    if ( ! retval )
    {
        /* if MTA kerberos app, we can't access the mibs */
        if ( reason != KRB_TEST_APPLICATION )
        {
            /* store to keep track of expiry */
            if ( pKrbCliAuthBlock->serviceType == APPLICATION_CMS )
            {
                secStoreToTimeTable(AP_CMS_FLAG, krbServiceName, krbServiceRealm,
                                    &credentials, &app_key);
            }
        }
        LIBDEBUG("INFO: secKrb5ClientAuthenticate() - AP-REQ/REP is OK!");

        if ( reason == KRB_SUBKEY_EXPIRED )
        {
            LOG(("INFO: secKrb5ClientAuthenticate() - Subkey Renewed Successfully."));
        }
    }
    else
    {
        if ( retval == SUBKEY_VALID )
        {
            LOG(("INFO: secKrb5ClientAuthenticate() - AP-REQ/REP Found Valid SubKey."));
            return 1;
        }
        else if ( retval == SUBKEY_WITHIN_GRACE_PERIOD )
        {
            LOG(("INFO: secKrb5ClientAuthenticate() - AP-REQ/REP Found SubKey within grace period."));
            return 1;
        }
        else
        {
            LOG(("ERROR: secKrb5ClientAuthenticate() - AP-REQ/REP Failed. Could not get sub-key."));
            return 1;
        }
    }
    ////////////////


    LOG(("sec Krb5ClientAuthenticate() - Deriving Application Keys..."));

    retval = pkrbSecCryptoDeriveSNMPv3Key(
                                         app_key.sub_key.sub_key_val,
                                         app_key.sub_key.sub_key_len,
                                         SNMPv3_SEED,
                                         sizeof(SNMPv3_SEED)-1,
                                         snmpv3_authkey,
                                         auth_tid,
                                         snmpv3_enckey,
                                         enc_tid);
    if ( !retval )
    {
        if ( ktracelevel > KTRACE_STATUS )
        {
            printf("secKrb5ClientAuthenticate() - Application Keys Derived OK!");
            printSNMPv3Keys(auth_tid, snmpv3_authkey, enc_tid, snmpv3_enckey);
        }
        
        if ( pClientKeys )
        {
            PROV_CLIENT_KEYS  *pCliKeys = (PROV_CLIENT_KEYS* )pClientKeys;
            
            copySNMPv3Keys(auth_tid, snmpv3_authkey, enc_tid, snmpv3_enckey, pCliKeys);
             
            LOG(("*** SEC SNMP Auth tid %d, Enc tid %d.",pCliKeys->provAuthKey.tid,pCliKeys->provEncrKey.tid));
//see what this will do
//#ifndef DEMO
            prfGetSecInfoBlock(&secInfoFuncBlock);
            if ( !secInfoFuncBlock.SnmpV3KeyInfoCB )
            {
                LOG(("ERROR: secKrb5ClientAuthenticate() - SNMPv3 KeyInfo Callback is NULL."));
                retval = 1; /* Problem! */
            }
            else
            {
                //Looks like these are all passed in. So we don't need to call this here
                //and we don't need to actually return these. We will have the data and
                //will setup SNMP after we return.
                //retval = secInfoFuncBlock.SnmpV3KeyInfoCB(pCliKeys, pASDReq, pASDRep);
            }
//#endif
        }
    }
      LIBDEBUG("NOW IN kStartAPRequest3 , &pClientKeys <%p>\n",pClientKeys);
    /* cleanup allocated memory */
      
      LIBDEBUG("\nTODO: ENABLE this call to fix a memory leak ---------------------------------\n\n");
      ///  secFreeCredsAndAppkey(&credentials, &app_key);
     LIBDEBUG("NOW IN kStartAPRequest4 , &pClientKeys <%p>\n",pClientKeys);
    return(retval) ? 1 : 0;

} /* end of kStartAPRequest */



////////////////////////////////////////
/*
 ******************************************************************************
 ** FUNCTION:   secKrb5ClientAuthenticate
 **
 ** PURPOSE:    Authenticates the Krb5 CLient Request: AS_REQ/REP, AP_REQ/REP
 **
 ** PARAMETERS:
 **             pKrbCliAuthBlock - pointer to KrbClient Authentication Block
 **             pASDReq - prov or CMS ASD
 **             pASDRep - prov or CMS ASD reply
 **             pClientKeys - resulting keys
 **
 ** RETURNS:    Success (0) or error code (<> 0)
 **
 ** NOTE:
 **
 ******************************************************************************
 */
//Who/why did this get changed here - it breaks everything -trc
//UINT32   secKrb5ClientKrbExchange(
UINT32   secKrb5ClientAuthenticate(
                                  KRBCLI_AUTH_BLOCK    *pKrbCliAuthBlock,
                                  void                 *pASDReq,
                                  void                 *pASDRep,
                                  void                 *pClientKeys)
{
    int                  krbto=10;
    krb5_error_code      retval;
    krb5_error_code      rvalue;
    int                  auth_tid;
    int                  enc_tid;
    int                  server_nonce;
    MtaApplicationKey    app_key;
    MtaCredentials       credentials;
    unsigned char        snmpv3_authkey[SNMPV3_HMAC_SHA1_SIZE];
    unsigned char        snmpv3_enckey[SNMPV3_DES_KEY_SIZE];
    //unsigned char        ipsec_outb_authkey[IPSec_ESP_HMAC_SHA1_SIZE];
    //unsigned char        ipsec_inb_authkey[IPSec_ESP_HMAC_SHA1_SIZE];
    //unsigned char        ipsec_outb_enckey[IPSec_ESP_3DES_KEY_SIZE];
    //unsigned char        ipsec_inb_enckey[IPSec_ESP_3DES_KEY_SIZE];
    KRB_REASON           reason;
    SEC_PROV_INFO_BLOCK  secInfoFuncBlock;
    int                  nonVolKrbFlag;

    /*   int           ManCertLen = 1000;  //set to max buf size
       unsigned char ManCert[1000];
       int           PSCertLen = 1000;
       unsigned char PSCert[1000];
       int           ServProvCertLen = 1000;
       unsigned char ServProvCert[1000];
       unsigned int  PsDevPrivExpLen = 128;
       unsigned char PsDevPrivExp[128];
       unsigned int  PsDevKeyModLen = 128;
       unsigned char PsDevKeyMod[128];
    */

    ///unsigned char test_vector_seed[50];
    ///unsigned char sig1[20];
    ///unsigned char sig2[20];
    ///int i;
    ///int tmp_len;

    //printf(".K - secKrb5ClientAuthenticate - start\n");

    if ( !pKrbCliAuthBlock || !pASDReq || !pASDRep || !pClientKeys )
    {
        LOG(("ERROR: sec Krb5ClientAuthenticate() - NULL Pointer in parameter(s).\n"));
        return 1;
    }

    if ( ktracelevel > KTRACE_INFO )
        DumpAuthBlock( "start of secKrb5ClientAuthenticate",pKrbCliAuthBlock);

#ifndef DEMO
    cmNvGetMtaKerberosFlag(&nonVolKrbFlag);
#else
    nonVolKrbFlag = 0;
#endif
    LOG(("INFO: sec Krb5ClientAuthenticate(): NonVolKrbFlag= %d.\n", nonVolKrbFlag));

    secLibInit();

    if ( (nonVolKrbFlag == 0x0) || (nonVolKrbFlag == 0x01) || (nonVolKrbFlag == 0x03) )
    {
        strcpy(mtaMac, pKrbCliAuthBlock->szMtaMac);
        strcpy(mtaFQDN, pKrbCliAuthBlock->szMtaFQDN);
        strcpy(krbServiceRealm, pKrbCliAuthBlock->szKrbServiceRealm);
        strcpy(krbServiceName, pKrbCliAuthBlock->szServiceName);
        strcpy(krbProvServFQDN, pKrbCliAuthBlock->szProvServerFQDN);
        strcpy(tgs_ip_addr, pKrbCliAuthBlock->szKdcIpAddress);
        server_nonce = pKrbCliAuthBlock->serverNonce;
        strcpy(srvc_ip_addr, pKrbCliAuthBlock->szServiceIpAddress);
        reason = pKrbCliAuthBlock->krbReason;


        //printf("\n.k AppType = %d.\n", pKrbCliAuthBlock->serviceType);
        //printf(".k MTA MAC Address = %s.\n", mtaMac);
        //printf(".k MTA FQDN =%s.\n", mtaFQDN);
        //printf(".k krbServiceRealm=%s.\n", krbServiceRealm);
        //printf(".k krbServiceName=%s.\n", krbServiceName);
        //printf(".k krbProvServFQDN=%s.\n", krbProvServFQDN);
        //printf(".k tgs_ip_addr=%s.\n", tgs_ip_addr);

#ifndef DEMO

        //trc- it looks like secKrbSetCert reads certs from nvram and puts
        //them in globals

        /* pass the certificates and RSA keys to kerberos */
        LOG(("Reading certificates/Keys from NVRAM.\n"));
        if ( secKrbSetCert() )
        {
            LOG(("ERROR: Failed to read certificates/keys from NVRAM."));
            return 1;
        }
#else
        //////////////////////////
        ////////////////////
        //We are calling into the app here 
        if ( secKrbSetCert_ch() )
        {
            LOG(("ERROR: Failed to read certificates/keys from NVRAM."));
            return 1;
        }

        /*
         if ( ! AppCHGetCertPSPrivateKeyParts(&PsDevPrivExp, PsDevPrivExpLen,
                                              &PsDevKeyMod,  PsDevKeyModLen) )
         {
             DumpBuf("from krb5client -PRIVATE EXP",PsDevPrivExp, PsDevPrivExpLen, 'x');
             DumpBuf("from krb5client -DEV MODULUS",PsDevKeyMod,  PsDevKeyModLen, 'x');
         }
 
         if ( ! AppCHGetCertPS(&PSCert, &PSCertLen) )
         {
             DumpBuf("from krb5client -PSCert",PSCert, PSCertLen, 'x');
             gmta_dev_cert_len = PSCertLen;
             memcpy(gmta_dev_cert,PSCert,PSCertLen);
             
         }
 
         if ( ! AppCHGetCertManCA(&ManCert, &ManCertLen) )
             DumpBuf("from krb5client -ManCert",ManCert, ManCertLen, 'x');
 
         if ( ! AppCHGetCertServProvCA( &ServProvCert, &ServProvCertLen ) )
             DumpBuf("from krb5client -ServProvCert",ServProvCert, ServProvCertLen, 'x');
 
         LOG(("Writing certificates/Keys to NVRAM. - Cablehome certs\n"));
         SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(MTA_MAN_CERT, ManCert, ManCertLen);
         SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(MTA_DEV_CERT, PSCertLen, PSCert);
         SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(TEL_ROOT_CERT,ServProvCertLen, ServProvCertLen);
         SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(MAT_DEV_MOD_KEY, PsDevKeyModLen, PsDevKeyMod);
         SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(MTA_DEV_PRIV_KEY, PsDevPrivExpLen, PsDevPrivExp);
 
         secKrbSetCert(PSCert,       PSCertLen,       //mta_dev_cert, sizeof(mta_dev_cert),
                       ManCert,      ManCertLen,      //mta_man_cert, sizeof(mta_man_cert),
                       PsDevKeyMod,  PsDevKeyModLen,  //rsa_mod, sizeof(rsa_mod),
                       PsDevPrivExp, PsDevPrivExpLen, // rsa_priv_exp, sizeof(rsa_priv_exp),
                       ServProvCert, ServProvCertLen);//tel_root_cert, sizeof(tel_root_cert));
 
             */
        ////////////////////////
#if (0)    

        /* On windows #include is used to read the certificates in */
        /* Write certificates to NVRAM */
        LOG(("Writing certificates/Keys to NVRAM.\n"));
        SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(
                                                          MTA_MAN_CERT, sizeof(mta_man_cert),mta_man_cert);
        SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(
                                                          MTA_DEV_CERT, sizeof(mta_dev_cert),mta_dev_cert);
        SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(
                                                          TEL_ROOT_CERT,sizeof(tel_root_cert),tel_root_cert);
        SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(
                                                          MAT_DEV_MOD_KEY, sizeof(rsa_mod), rsa_mod);
        SecLibGetNVRAMIface()->secWriteNVRAMMTACertKeyData(
                                                          MTA_DEV_PRIV_KEY,sizeof(rsa_priv_exp), rsa_priv_exp);

        /* pass the certificates and RSA keys to kerberos */
        //printf((".k Reading certificates/Keys from NVRAM.\n"));
        secKrbSetCert(mta_dev_cert, sizeof(mta_dev_cert),
                      mta_man_cert, sizeof(mta_man_cert),
                      rsa_mod, sizeof(rsa_mod),
                      rsa_priv_exp, sizeof(rsa_priv_exp),
                      tel_root_cert, sizeof(tel_root_cert));
#endif //ifdef 0

#endif

        LOG(("sec Krb5ClientAuthenticate() - CMS_APP Kerberos Exchange ..."));
        /* Do only when validating certificate is required */
        /* Comment out secCertValidate in pkinitreply.c */

        credentials.service.realm_len = 0;
        credentials.service.name_len = 0;
        credentials.session_key.session_key_len = 0;
        credentials.tkt.tkt_len = 0;
        app_key.sub_key.sub_key_len = 0;
    }
    else
    {
        LOG(("WARNING: sec Krb5ClientAuthenticate() - AS-REQ/REP skipped due to non-vol kerberos flag value."));
        retval = 0;
#ifndef DEMO
        if ( pKrbCliAuthBlock->serviceType == APPLICATION_PROV )
        {
            PROV_CLIENT_KEYS  *pCliKeys = (PROV_CLIENT_KEYS* )pClientKeys;

            LOG(("WARNING: sec Krb5ClientAuthenticate() - Simulating SNMPv3 Keys Setting in NoAuthNoPriv."));
            prfGetSecInfoBlock(&secInfoFuncBlock);
            if ( !secInfoFuncBlock.SnmpV3KeyInfoCB )
            {
                LOG(("ERROR: secKrb5ClientAuthenticate() - SNMPv3 KeyInfo Callback is NULL."));
                retval = 1; /* Problem! */
            }
            else
            {
                /* Because we are not supposed to make any SNMPv3 Key-Distribution
                   let's "clear" the keys, ASD-Req and ASD-Rep just to
                   have SNMPv3 NoAuthNoProv mode (NOT PACKETCABLE COMPLIANT!!!).
                */
                memset((void*)pCliKeys, 0, sizeof(PROV_CLIENT_KEYS));
                memset((void*)pASDReq, 0, sizeof(PROV_ASD_APREQ));
                memset((void*)pASDRep, 0, sizeof(PROV_ASD_APREP));
                retval = secInfoFuncBlock.SnmpV3KeyInfoCB(pCliKeys, pASDReq, pASDRep);
            }
        }
#endif
        return retval;
    }

    if ( ((pKrbCliAuthBlock->serviceType == APPLICATION_PROV) &&
          ( nonVolKrbFlag <= 0x01 )) ||
         (( pKrbCliAuthBlock->serviceType == APPLICATION_CMS) &&
          (nonVolKrbFlag == 0x0 ) || (nonVolKrbFlag == 0x03)) )
    {
        /* Send AS_REQ, process AS_REP results into &credentials */
        LOG(("INFO: sec Krb5ClientAuthenticate() - Sending AS-REQ/REP..."));
        //printf(".K - secKrb5ClientAuthenticate - calling secGetKrbCredentials\n");


        //trc- should be able to put mtaMac in mtaFQDN here and have no problem.

        //retval = secGetKrbCredentials(mtaFQDN,
        retval = secGetKrbCredentials(mtaMac,
                                      tgs_ip_addr,
                                      pKrbCliAuthBlock->serviceType,
                                      krbServiceName,
                                      krbServiceRealm,
                                      krbProvServFQDN,
                                      krbto,
                                      reason,
                                      &credentials);
        //printf(".K - secKrb5ClientAuthenticate: returned from secGetKrbCredentials with (%d)\n",retval);

        if ( ! retval )
        {
            LOG(("INFO: sec Krb5ClientAuthenticate() - AS-REQ/REP is OK!"));
            //AppReportKerbStatusCallback(0);//kKerberosASExchangeSuccessful);

            /* if MTA kerberos app, we can't access the mibs */
            if ( reason != KRB_TEST_APPLICATION )
            {
                if ( ( reason == KRB_BOOTUP ) ||
                     ( reason == KRB_TICKET_EXPIRED) || 
                     ( reason == KRB_BADKEYVER_ERROR) )
                {
                    /* Store to keep track of the expiry */
                    if ( pKrbCliAuthBlock->serviceType == APPLICATION_PROV )
                        secStoreToTimeTable(AS_PROV_FLAG, krbServiceName, krbServiceRealm,
                                            &credentials, &app_key);
                    else
                        secStoreToTimeTable(AS_CMS_FLAG, krbServiceName, krbServiceRealm,
                                            &credentials, &app_key);
                }
            }

            if ( reason == KRB_TICKET_EXPIRED )
            {
                LOG(("secKrb5ClientAuthenticate() - Ticket Renewed Successfully."));
                secFreeCredsAndAppkey(&credentials, &app_key);
                return retval;
            }
            if ( reason == KRB_BADKEYVER_ERROR )
            {
                LOG(("sec Krb5ClientAuthenticate() - Ticket Granted Successfully for BADKEYVER error."));
            }
            LOG(("INFO: secKrb5ClientAuthenticate() - Sending AP-REQ/REP ..."));
            if ( reason == KRB_REKEY )
            {
                auth_tid = pKrbCliAuthBlock->rekeyInfoBlock.authTID;
                enc_tid = pKrbCliAuthBlock->rekeyInfoBlock.encTID;
            }
            else
            {
                auth_tid = 0;
                enc_tid = 0;
            }

            if ( ((pKrbCliAuthBlock->serviceType == APPLICATION_PROV) &&
                  (( nonVolKrbFlag <= 0x01 ) || ( nonVolKrbFlag == 0x03 ))) || 
                 (( pKrbCliAuthBlock->serviceType == APPLICATION_CMS) &&
                  (nonVolKrbFlag == 0x0 )) )
            {
                LIBDEBUG(".k  secKrb5ClientAuthentacate(): calling secGetKrbApplicationKey to send the AP\n");

                retval = secGetKrbApplicationKey(mtaFQDN,
                                                 krbServiceName,
                                                 srvc_ip_addr,
                                                 krbServiceRealm,
                                                 krbto,
                                                 pKrbCliAuthBlock->serviceType,
                                                 server_nonce,
                                                 pASDReq,
                                                 pASDRep,
                                                 &credentials,
                                                 &app_key,
                                                 &auth_tid,
                                                 &enc_tid,
                                                 reason);

                /* analyze return value */
                rvalue = retval + ERROR_TABLE_BASE_krb5;
                switch ( rvalue )
                {
                case KRB5KRB_AP_ERR_BADKEYVER:
                    if ( pKrbCliAuthBlock->serviceType == APPLICATION_CMS )
                    {
                        LOG(("ERROR: sec Krb5ClientAuthenticate() - BAD KEY VERSION ERROR."));
                        return rvalue;
                    }
                    break;
                default:
                    break;
                }

                /* if this is a response to a rekey, get the necessary info
                 * from the rekey message.
                 */
                if ( reason == KRB_REKEY )
                {
                    auth_tid = pKrbCliAuthBlock->rekeyInfoBlock.authTID;
                    enc_tid = pKrbCliAuthBlock->rekeyInfoBlock.encTID;
                    app_key.sec_params_lifetime =
                    pKrbCliAuthBlock->rekeyInfoBlock.secParamLifeTime;
                    app_key.grace_period = pKrbCliAuthBlock->rekeyInfoBlock.gracePeriod;
                }

                if ( ! retval )
                {
                    /* if MTA kerberos app, we can't access the mibs */
                    if ( reason != KRB_TEST_APPLICATION )
                    {
                        /* store to keep track of expiry */
                        if ( pKrbCliAuthBlock->serviceType == APPLICATION_CMS )
                        {
                            secStoreToTimeTable(AP_CMS_FLAG, krbServiceName, krbServiceRealm,
                                                &credentials, &app_key);
                        }
                    }
                    LOG(("INFO: secKrb5ClientAuthenticate() - AP-REQ/REP is OK!"));
                    if ( reason == KRB_SUBKEY_EXPIRED )
                    {
                        LOG(("INFO: secKrb5ClientAuthenticate() - Subkey Renewed Successfully."));
                    }
                }
                else
                {
                    if ( retval == SUBKEY_VALID )
                    {
                        LOG(("INFO: secKrb5ClientAuthenticate() - AP-REQ/REP Found Valid SubKey."));
                        return 1;
                    }
                    else if ( retval == SUBKEY_WITHIN_GRACE_PERIOD )
                    {
                        LOG(("INFO: secKrb5ClientAuthenticate() - AP-REQ/REP Found SubKey within grace period."));
                        return 1;
                    }
                    else
                    {
                        LOG(("ERROR: secKrb5ClientAuthenticate() - AP-REQ/REP Failed. Could not get sub-key."));
                        return 1;
                    }
                }
            }
            else
            {
                LOG(("WARNING: secKrb5ClientAuthenticate() - AP-REQ/REP skipped due to non-vol kerberos flag value."));
                return 0;
            }
        }
        else
        {
            LOG(("ERROR: secKrb5ClientAuthenticate() - AS-REQ/REP Failed. Could not get Credentials."));
            return 1;
        }
    }
    else
    {
        LOG(("WARNING: secKrb5ClientAuthenticate() - AS-REQ/REP skipped due to non-vol kerberos flag value."));
        return 0;
    }

    switch ( pKrbCliAuthBlock->serviceType )
    {
    case APPLICATION_CMS:
        // outputCmsAsdRep(pASDRep);

        /* derive IPSEC keys */
        // retval = pkrbSecCryptoDeriveIPSecKey(
        //       app_key.sub_key.sub_key_val,
        //       app_key.sub_key.sub_key_len,
        //       IPSEC_SEED,
        //       sizeof(IPSEC_SEED)-1,
        //       ipsec_outb_authkey,
        //       ipsec_outb_enckey,
        //       ipsec_inb_authkey,
        //       ipsec_inb_enckey,
        //       auth_tid,
        //       enc_tid);
        //
        // if ( ! retval )
        // {
        //    printIPSECKeys(auth_tid,
        //          ipsec_outb_authkey,
        //          ipsec_inb_authkey,
        //          enc_tid,
        //          ipsec_outb_enckey,
        //          ipsec_inb_enckey);
        //
        //    if (pClientKeys)
        //    {
        //       CMS_CLIENT_KEYS   *pCliKeys = (CMS_CLIENT_KEYS* )pClientKeys;
        //
        //       copyIPSECKeys(auth_tid,
        //             ipsec_outb_authkey,
        //             ipsec_inb_authkey,
        //             enc_tid,
        //             ipsec_outb_enckey,
        //             ipsec_inb_enckey,
        //             pCliKeys);
//
//#ifndef WIN32
//               prfGetSecInfoBlock(&secInfoFuncBlock);
//               if (!secInfoFuncBlock.IpsecKeyInfoCB)
//               {
//                  LOG(("ERROR: secKrb5ClientAuthenticate() - IPSEC KeyInfo Callback is NULL."));
//                  retval = 1; /* Problem! */
//               }
//               else
//               {
//                  retval = secInfoFuncBlock.IpsecKeyInfoCB(krbServiceName, &app_key, pCliKeys, pASDReq, pASDRep);
//               }
//#endif
        //          }
        //       }
        //       else
        //       {
        //          LOG(("ERROR: secKrb5ClientAuthenticate() - Could not derive IPSEC Keys."));
        //       }
        //
        //       /* cleanup allocated memory */
        //       secFreeCredsAndAppkey(&credentials, &app_key);
        //
        //       break;

    case APPLICATION_PROV:
        //outputProvAsdRep(pASDRep);

        LOG(("sec Krb5ClientAuthenticate() - Deriving Application Keys..."));

//#if WIN32
//#if 0
//         if (!alopa_fopened_once)
//         {
//            alopa_subkey_bin = fopen("alopa_subkey.bin","rb");
//         }
//#endif
//#endif
//
//#if WIN32
//#if 0
//         if (!alopa_fopened_once)
//         {
//            app_key.sub_key.sub_key_len = fread(app_key.sub_key.sub_key_val,
//                  1, 5120, alopa_subkey_bin);
//            fclose(alopa_subkey_bin);
//            alopa_fopened_once = 1;
//         }
//#endif
//#endif

#if 0
        for ( i=0;i<25;i++ )
            app_key.sub_key.sub_key_val[i] = i+1;
        app_key.sub_key.sub_key_len = 25;
        /* memcpy(test_vector_seed, "Hi There", 8); */
        for ( i=0;i<50;i++ )
            test_vector_seed[i] = 0xcd;

        retval = pkrbSecCryptoDeriveSNMPv3Key(
                                             app_key.sub_key.sub_key_val,
                                             app_key.sub_key.sub_key_len,
                                             test_vector_seed,
                                             50,
                                             snmpv3_authkey,
                                             auth_tid,
                                             snmpv3_enckey,
                                             enc_tid);
#endif

        retval = pkrbSecCryptoDeriveSNMPv3Key(
                                             app_key.sub_key.sub_key_val,
                                             app_key.sub_key.sub_key_len,
                                             SNMPv3_SEED,
                                             sizeof(SNMPv3_SEED)-1,
                                             snmpv3_authkey,
                                             auth_tid,
                                             snmpv3_enckey,
                                             enc_tid);

#if (SEC_PC_COMPLIANT == 0)
        if ( !auth_tid && retval )
        {
            retval = 0;
        }
#endif

        if ( !retval )
        {
            LOG(("secKrb5ClientAuthenticate() - Application Keys Derived OK!"));
            if ( ktracelevel > KTRACE_INFO )
                printSNMPv3Keys(auth_tid, snmpv3_authkey, enc_tid, snmpv3_enckey);

            if ( pClientKeys )
            {
                PROV_CLIENT_KEYS  *pCliKeys = (PROV_CLIENT_KEYS* )pClientKeys;

                copySNMPv3Keys(auth_tid, snmpv3_authkey, enc_tid, snmpv3_enckey, pCliKeys);
                LOG(("*** SEC SNMP Auth tid %d, Enc tid %d.",
                     pCliKeys->provAuthKey.tid,
                     pCliKeys->provEncrKey.tid));
//see what this will do
//#ifndef DEMO
                prfGetSecInfoBlock(&secInfoFuncBlock);
                if ( !secInfoFuncBlock.SnmpV3KeyInfoCB )
                {
                    LOG(("ERROR: secKrb5ClientAuthenticate() - SNMPv3 KeyInfo Callback is NULL."));
                    retval = 1; /* Problem! */
                }
                else
                {
                    retval = secInfoFuncBlock.SnmpV3KeyInfoCB(pCliKeys, pASDReq, pASDRep);
                }
//#endif
            }
        }

        /* cleanup allocated memory */
        secFreeCredsAndAppkey(&credentials, &app_key);
        break;

    default:
        LOG(("ERROR: secKrb5ClientAuthenticate() - Wrong Service Type (%d) Requiested in input parameter.\n", pKrbCliAuthBlock->serviceType));
        return 1;
    }

    return(retval) ? 1 : 0;




} /* end of secKrb5ClientAuthenticate() */


void DumpCredentials(char * msg, MtaCredentials *cred)
{
    printf (".k=== Dump MtaCredentials: [%s] === \n",msg);
    DumpBuf(".k service.realm  ",cred->service.realm,(int)(cred->service.realm_len),'c'); 
    printf (".k service.realm_len            = <%d>\n",cred->service.realm_len);
    DumpBuf(".k service.name   ",cred->service.name,(int)(cred->service.name_len),'c'); 
    printf (".k service.name_len             = <%d>\n",(int)cred->service.name_len);
    printf (".k session_key.session_key_type = <%d>\n",(int)cred->session_key.session_key_type);
    printf (".k session_key.session_key_len  = <%d>\n",(int)cred->session_key.session_key_len);
    DumpBuf(".k session_key.session_key_val",cred->session_key.session_key_val,(int)(cred->session_key.session_key_len),'x'); 
    DumpBuf(".k tkt.tkt_val    ",cred->tkt.tkt_val,(int)(cred->tkt.tkt_len),'x');
    printf (".k tkt.tkt_len                  = <%d>\n",(int)cred->tkt.tkt_len);
    printf (".k tkt_times.auth_time          = <%d>\n",(int)cred->tkt_times.auth_time);
    printf (".k tkt_times.start_time         = <%d>\n",(int)cred->tkt_times.start_time);
    printf (".k tkt_times.ene_time           = <%d>\n",(int)cred->tkt_times.end_time);
    printf (".k tkt_times.renew_till         = <%d>\n",(int)cred->tkt_times.renew_till);
    printf("\n");
}


/////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//   #ifdef WIN32
/*
 *****************************************************************************
 ** FUNCTION:     Load_SecLibDLL
 **
 ** PURPOSE:      Explicitly loads the SecLib.dll, and maps the API function
 **               calls to global function pointers
 **
 ** PARAMETERS:   hLibrary - the handle to the DLL library
 **
 ** RETURNS:      success or failure
 **
 ** NOTE:
 **
 **
 *****************************************************************************
 */
/*int Load_SecLibDLL (HINSTANCE *hLibrary)
{
   // Load dll 
   *hLibrary = LoadLibrary("SecLibDLL.dll");

   if (*hLibrary != NULL)
   {
      /// get address of API calls in SecLibDLL.dll 
      pkrbSecCryptoDeriveIPSecKey = (_pkrbSecCryptoDeriveIPSecKey) GetProcAddress(*hLibrary, "secCryptoDeriveIPSecKey");
      if (pkrbSecCryptoDeriveIPSecKey == NULL)
      {
         printf("Error in mappping pkrbSecCryptoDeriveIPSecKey call");
         FreeLibrary(*hLibrary);
         return 1;
      }

      // get address of API calls in SecLibDLL.dll 
      pkrbSecCryptoDeriveSNMPv3Key = (_pkrbSecCryptoDeriveSNMPv3Key) GetProcAddress(*hLibrary, "secCryptoDeriveSNMPv3Key");
      if (pkrbSecCryptoDeriveSNMPv3Key == NULL)
      {
         printf("Error in mappping pkrbSecCryptoDeriveSNMPv3Key call");
         FreeLibrary(*hLibrary);
         return 1;
      }
   }
   else
   {
      printf("Error in Loading DLL SecLibDLL.dll\nPlease ensure file KrbSrvcLib.Dll is in the Windows directory");
      return 1;
   }

   return 0;
}
#endif
*/

/*
 *****************************************************************************
 ** FUNCTION:     outputCmsAsdRep
 **
 ** PURPOSE:      output the ASD AP Rep from callagent
 **
 ** PARAMETERS:   apRepAsd - in - ASD pointer
 **
 ** RETURNS:      none
 **
 ** NOTE:
 **
 **
 *****************************************************************************
 */
/*static void outputCmsAsdRep(CMS_ASD_APREP *apRepAsd)
{
   printf("Call Agent's IPSEC ASD (inbound SPI) is 0x%x\r\n", apRepAsd->inbound_SPI);
}
*/
/*
******************************************************************************
** FUNCTION:   printIPSECKeys
**
** PURPOSE:    print snmp v3 keys
**
** PARAMETERS:
**
** RETURNS:    nothing
**
** NOTE:
**
******************************************************************************
*/
/*void printIPSECKeys(
      int             auth_tid,
      unsigned char   *ipsec_outb_authkey,
      unsigned char   *ipsec_inb_authkey,
      int             enc_tid,
      unsigned char   *ipsec_outb_enckey,
      unsigned char   *ipsec_inb_enckey)
{
   int i;

   printf("Derived keys for IPSEC:.\n");
   if (auth_tid == IPSec_ESP_HMAC_SHA1_TID)
   {
      printf("Outbound authentication (SHA1): ");
      for (i=0;i<IPSec_ESP_HMAC_SHA1_SIZE;i++)
         printf("%x ",ipsec_outb_authkey[i]);
      printf("\nInbound authentication (SHA1): ");
      for (i=0;i<IPSec_ESP_HMAC_SHA1_SIZE;i++)
         printf("%x ",ipsec_inb_authkey[i]);
      printf("\n");
   }
   else if (auth_tid == IPSec_ESP_HMAC_MD5_TID)
   {
      printf("Outbound authentication (MD5): ");
      for (i=0;i<IPSec_ESP_HMAC_MD5_SIZE;i++)
         printf("%x ",ipsec_outb_authkey[i]);
      printf("\nInbound authentication (MD5): ");
      for (i=0;i<IPSec_ESP_HMAC_MD5_SIZE;i++)
         printf("%x ",ipsec_inb_authkey[i]);
      printf("\n");
   }
   if (enc_tid == IPSec_ESP_3DES_TID)
   {
      printf("Outbound encryption (3DES): ");
      for (i=0;i<IPSec_ESP_3DES_KEY_SIZE;i++)
         printf("%x ", ipsec_outb_enckey[i]);
      printf("\nInbound encryption (3DES): ");
      for (i=0;i<IPSec_ESP_3DES_KEY_SIZE;i++)
         printf("%x ", ipsec_inb_enckey[i]);
      printf("\n");
   }
   else if (enc_tid == IPSec_ESP_NULL_TID)
   {
      printf("Outbound encryption (NULL) ");
      printf("\nInbound encryption (NULL) \n");
   }
}
*/
/*
 ******************************************************************************
 ** FUNCTION:   copyIPSECKeys
 **
 ** PURPOSE:    copy IPSEC keys into the CMS_CLIENT_KEYS struct
 **
 ** PARAMETERS:
 **
 ** RETURNS:    nothing
 **
 ** NOTE:
 **
 ******************************************************************************
 */
/*void copyIPSECKeys(
      int             auth_tid,
      unsigned char   *ipsec_outb_authkey,
      unsigned char   *ipsec_inb_authkey,
      int             enc_tid,
      unsigned char   *ipsec_outb_enckey,
      unsigned char   *ipsec_inb_enckey,
      CMS_CLIENT_KEYS *cms_key)
{

   if (auth_tid == IPSec_ESP_HMAC_SHA1_TID)
   {
      memcpy(cms_key->cmsAuthKeyRx.key, ipsec_inb_authkey, IPSec_ESP_HMAC_SHA1_SIZE);
      memcpy(cms_key->cmsAuthKeyTx.key, ipsec_outb_authkey, IPSec_ESP_HMAC_SHA1_SIZE);
      cms_key->cmsAuthKeyRx.tid = auth_tid;
      cms_key->cmsAuthKeyTx.tid = auth_tid;
   }
   else if (auth_tid == IPSec_ESP_HMAC_MD5_TID)
   {
      memcpy(cms_key->cmsAuthKeyRx.key, ipsec_inb_authkey, IPSec_ESP_HMAC_MD5_SIZE);
      memcpy(cms_key->cmsAuthKeyTx.key, ipsec_outb_authkey, IPSec_ESP_HMAC_MD5_SIZE);
      cms_key->cmsAuthKeyRx.tid = auth_tid;
      cms_key->cmsAuthKeyTx.tid = auth_tid;
   }
   else
   {
      printf("ERROR: BAD TID for IPSEC Authentication %d .\n", auth_tid);
   }

   if (enc_tid == IPSec_ESP_3DES_TID)
   {
      memcpy(cms_key->cmsEncrKeyRx.key, ipsec_inb_enckey, IPSec_ESP_3DES_KEY_SIZE);
      memcpy(cms_key->cmsEncrKeyTx.key, ipsec_outb_enckey, IPSec_ESP_3DES_KEY_SIZE);
      cms_key->cmsEncrKeyRx.tid = enc_tid;
      cms_key->cmsEncrKeyTx.tid = enc_tid;
   }
   else if  (enc_tid == IPSec_ESP_NULL_TID)
   {
      cms_key->cmsEncrKeyRx.key[0] = '\0';
      cms_key->cmsEncrKeyTx.key[0] = '\0';
      cms_key->cmsEncrKeyRx.tid = enc_tid;
      cms_key->cmsEncrKeyTx.tid = enc_tid;
   }
   else
   {
      printf("ERROR: BAD TID for IPSEC encryption %d .\n", enc_tid);
   }
}
*/
/*
*****************************************************************************
** FUNCTION:    makeProvServiceName
**
** PURPOSE:     Get Service name in the format "MTA-Prov-xx:xx:xx:xx:xx:xx"
**              where "xx:xx:xx:xx:xx:xx" is the MAC address of the MTA
**
** PARAMETERS:  mtaMac - in - MTA's MAC address
**              krbServiceName    - output: principal name of application server
**
** RETURNS:      success or error
**
** NOTE:
**
**
*****************************************************************************
*/
/* //trc-  this is also in root.c
static int makeProvServiceName(char *mtaMac, char* krbServiceName)
{

   if (*mtaMac == '\0')
   {
      return 1;
   }

   strcpy(krbServiceName, "MTA-Prov-");
   strcat(krbServiceName, mtaMac);

   return 0;

} *//* end of makeProvServiceName */

















