/***************************************************************************
*    Copyright 2000  Broadcom Corporation
*    All Rights Reserved
*    No portions of this material may be reproduced in any form without the
*    written permission of:
*             Broadcom Corporation
*             16251 Laguna Canyon Road
*             Irvine, California  92618
*    All information contained in this document is Broadcom Corporation
*    company private, proprietary, and trade secret.
*
****************************************************************************
*
*    Filename: log.c
*    Creation Date: 14 June 2001 (v0.00)
*    VSS Info:
*        $Revision: 1.2 $
*        $Date: 2002/11/07 21:16:53 $
*
****************************************************************************
*    Description:
*
*        This file provides a set of functions for logging messages to the
*        console. These functions should be called indirectly through the
*        LOG() and LOGMSG() macros.
*
****************************************************************************/

#include <hausenv.h>
#include <stdio.h>
#include <stdarg.h>

#include <KerbStatus.h>
/*
*****************************************************************************
** FUNCTION:   Log
**
** PURPOSE:    Log a debug message to the console
**
** PARAMETERS: format  - input - the format string
**             ...     - input - variable arguments
**
** RETURNS:    Nothing
**
** NOTE:
*****************************************************************************
*/
void Log( char const *format,... )
{
    va_list marker;
    if ( ktracelevel > KTRACE_LOGFUNC )
    {
        va_start( marker, format );
        vprintf( format, marker );
        puts("");
        fflush(stdout);
        va_end( marker );
    }
}

/*
*****************************************************************************
** FUNCTION:   LogMsg
**
** PURPOSE:    Log a debug string to the console
**
** PARAMETERS: string  - input - the string to log
**
** RETURNS:    Nothing
**
** NOTE:
*****************************************************************************
*/
void LogMsg( char* string )
{
    if ( ktracelevel > KTRACE_LOGFUNC )
        puts( string );
}

