/***************************************************************************
*    Copyright 2001  Broadcom Corporation
*    All Rights Reserved
*    No portions of this material may be reproduced in any form without the
*    written permission of:
*             Broadcom Corporation
*             16251 Laguna Canyon Road
*             Irvine, California  92618
*    All information contained in this document is Broadcom Corporation
*    company private, proprietary, and trade secret.
*
****************************************************************************
*
*    Filename: expBackoffRetry.h
*    Creation Date: 27 November 2001 (v0.00)
*    VSS Info:
*        $Revision: 1.2 $
*        $Date: 2005/02/17 21:13:12 $
*
****************************************************************************
*    Description:
*
*      Header file for Implementation of exponential backoff and retry
*      algorithm for security
*
****************************************************************************/

#ifndef EXPBACKOFFRETRY_H
#define EXPBACKOFFRETRY_H



#ifdef __cplusplus
extern "C"
{
#endif


#include <string.h>
#include <SecLib.h>
#include <krb5client.h>
#include <ChKerbNamespace.h>

/*
******************************************************************************
** FUNCTION:  secUpdateExpBackoffRetryTable
**
** PURPOSE:   Update/get timers from back off retry table
**
** PARAMETERS:   flag - AS or AP, prove or CMS
**               endpt - end point ID in case of ant CMS timers
**               name - realm, cms fqdn, or any other name IDs
**
** RETURNS:
**
** NOTE:
**
******************************************************************************
*/
void secUpdateExpBackoffRetryTable(
      SEC_TM_FLAG          flag,
      int                  endpt,
      unsigned char        *name);


/*
******************************************************************************
** FUNCTION: secGetRTT 
**
** PURPOSE:   get timers from back off retry table
**
** PARAMETERS:   flag - AS or AP, prov or CMS
**               name - realm or RQDN name
**
** RETURNS:
**
** NOTE:
**
******************************************************************************
*/
unsigned int secGetRTT(int flag, unsigned char *name);

