/***************************************************************************
*    Copyright 2001  Broadcom Corporation
*    All Rights Reserved
*    No portions of this material may be reproduced in any form without the
*    written permission of:
*             Broadcom Corporation
*             16251 Laguna Canyon Road
*             Irvine, California  92618
*    All information contained in this document is Broadcom Corporation
*    company private, proprietary, and trade secret.
*
****************************************************************************
*
*    Filename: krbTasks.h
*    Creation Date: 19 Sept. 2001 (v0.00)
*    VSS Info:
*        $Revision: 1.2 $
*        $Date: 2005/02/17 21:13:15 $
*
****************************************************************************
*    Description:
*       Implementation of Wake UP and Time Manager tasks for security
*
*
****************************************************************************/

#include <ChKerbNamespace.h>

/* constants to identify the kind of service */
#define  KRB_IPSEC_DOI    1
#define  KRB_SNMPV3_DOI   2


/*
*****************************************************************************
** FUNCTION:  krbStartTasks
**
** PURPOSE:   Create and call the threads for wake up and time management
**
** PARAMETERS:
**
**
** RETURNS:   Success or failure
*****************************************************************************
*/
int krbStartTasks(void);


/*
*****************************************************************************
** FUNCTION:  krbShutDownTasks
**
** PURPOSE:   Shutdown the task
** PARAMETERS:
**
**
** RETURNS:   Success or failure
*****************************************************************************
*/
int krbShutDownTasks(void);


/*
*****************************************************************************
** FUNCTION:  reAuthenticate
**
** PURPOSE:   renew any ticket or subkey if expired
**
** PARAMETERS:   flag - AS or AP, prov or CMS
**               fqdn - only in case of CMS
**
** RETURNS:
**
** NOTE:
**
*****************************************************************************
*/
void reAuthenticate(int flag, unsigned char *fqdn);

