/***************************************************************************
*    Copyright 2001  Broadcom Corporation
*    All Rights Reserved
*    No portions of this material may be reproduced in any form without the
*    written permission of:
*             Broadcom Corporation
*             16251 Laguna Canyon Road
*             Irvine, California  92618
*    All information contained in this document is Broadcom Corporation
*    company private, proprietary, and trade secret.
*
****************************************************************************
*
*    Filename: serverAuthKey.h
*    Creation Date: 30 October 2001 (v0.00)
*    VSS Info:
*        $Revision: 1.2 $
*        $Date: 2005/02/17 21:13:32 $
*
****************************************************************************
*    Description:
*
*      Header file for Implementation of server authentication key
*
****************************************************************************/

#ifndef SERVERAUTHKEY_H
#define SERVERAUTHKEY_H



#ifdef __cplusplus
extern "C"
{
#endif


#include <string.h>
#include <SecLib.h>
#include <ChKerbNamespace.h>


typedef enum
{
   SERVER_AUTH_KEY_FOUND,
   SERVER_AUTH_KEY_NOT_FOUND,
};
   
/*
******************************************************************************
** FUNCTION:  secUpdateServerAuthKey 
**
** PURPOSE:   Update sever auth key for this call agent
**
** PARAMETERS:
**    1. session key value
**    2. fqdn of call agent
**
**
** RETURNS:
**
** NOTE:
**
******************************************************************************
*/
void secUpdateServerAuthKey(
      unsigned char   *session_key,
      unsigned long   session_key_len,
      unsigned char   *fqdn);


/*
******************************************************************************
** FUNCTION:  secGetServerAuthKey 
**
** PURPOSE:   retreive server auth key 
**
** PARAMETERS:
**    1. fqdn of call agent
**    2. server authentication key
**
**
** RETURNS:
**    index to the table if found,
**    0 otherwise.
**
** NOTE:
**     Caller responsible for allocating space for server authentication key
**
******************************************************************************
*/
unsigned long secGetServerAuthKey(
      unsigned char   *fqdn,
      unsigned char   *server_auth_key,
      unsigned long   *server_key_len);

 
/*
******************************************************************************
** FUNCTION:  secRemoveServerAuthKey 
**
** PURPOSE:   remove server auth key for the fqdn entry
**
** PARAMETERS:
**    1. fqdn of call agent
**
**
** RETURNS:
**
** NOTE:
**
******************************************************************************
*/
unsigned long secRemoveServerAuthKey(
      unsigned char   *fqdn);


#ifdef __cplusplus
}
#endif

#endif
