/*
 * Author: Sean Dunlap */

#include "includes.h"

void syslog (int __pri, const char *fmt, ...)
{
    //if ( __pri <= trace_level )    //check for permission
    {
        va_list args;

        va_start( args, fmt );
        vfprintf( stdout, fmt, args );
        va_end( args );

        fflush( stdout );
    }
}

void openlog (__const char *__ident, int __option, int __facility)
{

}

void closelog (void)
{

}

/*
 * Close all file descriptors greater than or equal to lowfd.
 */
void
closefrom(int lowfd)
{
}

int LINUX_execv( char * name, char ** av )
{
    printf("WARNING!!!  Inside ECOS_execv!\n");
    return 0;
}

pid_t waitpid (pid_t pid, int * arg2, int arg3)
{
    printf("WARNING!!!  Inside waitpid!\n");
    return 0;
}

int chmod (const char *__path, mode_t __mode )
{
    return 0;
}

int chown (const char *__path, uid_t __owner, gid_t __group )
{
    return 0;
}

int chroot (const char *__path )
{
    return 0;
}

#if 0
pid_t fork(void )
{
    // In the original process (the parent) the return value of fork
    // will be the process ID of the child. In the new child process
    // the return value of fork will be 0.
    return 0;
};
#endif

/*
 * NB. duplicate __progname in case it is an alias for argv[0]
 * Otherwise it may get clobbered by setproctitle()
 */
char *ssh_get_progname(char *argv0)
{
    return "This is my progname";
}

//DAEMON(3)                BSD Library Functions Manual                DAEMON(3)
//
//DESCRIPTION
//     The daemon() function is for programs wishing to detach themselves from
//     the controlling terminal and run in the background as system daemons.
//
//     Unless the argument nochdir is non-zero, daemon() changes the current
//     working directory to the root (/).
//
//     Unless the argument noclose is non-zero, daemon() will redirect standard
//     input, standard output, and standard error to /dev/null.
//
//RETURN VALUES
//     The daemon() function returns the value 0 if successful; otherwise the
//     value -1 is returned and the global variable errno is set to indicate the
//     error.
//
int daemon(int nochdir, int noclose)
{
    return 0;
}


// this is a replacement for unix signals
void ECOS_signal( int event, void (* handler_function)(int event)  )
{
    // sometimes, the signal handlers themselves send themselves the same signal.
    // I don't understand why this would be, but we need to detect it to prevent
    // endless loop.  sighup_handler() is an example of this.
    static void (*prev_handler_function)(int event) = NULL;

    if( handler_function != prev_handler_function )
    {
        prev_handler_function = handler_function;

        // invoke the handler function
        handler_function( event );
    }

    prev_handler_function = NULL;
}


int ECOS_chdir(const char *path)
{
    return 0;
}

int ECOS_socketpair(int af, int type, int protocol, int sv[2])
{
    sv[0] = socket(af, type, protocol);
    sv[1] = socket(af, type, protocol);
}


/*
 * Appends src to string dst of size siz (unlike strncat, siz is the
 * full size of dst, not space left).  At most siz-1 characters
 * will be copied.  Always NUL terminates (unless siz <= strlen(dst)).
 * Returns strlen(src) + MIN(siz, strlen(initial dst)).
 * If retval >= siz, truncation occurred.
 */
size_t strlcat(dst, src, siz)
        char *dst;
        const char *src;
        size_t siz;
{
        char *d = dst;
        const char *s = src;
        size_t n = siz;
        size_t dlen;
         /* Find the end of dst and adjust bytes left but don't go past end */
        while (n-- != 0 && *d != '\0')
                d++;
        dlen = d - dst;
        n = siz - dlen;

        if (n == 0)
                return(dlen + strlen(s));
        while (*s != '\0') {
                if (n != 1) {
                        *d++ = *s;
                        n--;
                }
                s++;
        }
        *d = '\0';

        return(dlen + (s - src));       /* count does not include NUL */
}

typedef void (*mysig_t)(int);

void
mysignal(int sig, mysig_t act)
{
    //printf("inside mysignal().  Not implemented yet.\n");
}


void ecos_fatal (const char * fmt, ...)
{
	char buf[1024];
	va_list args;
	va_start(args, fmt);

    printf("FATAL ERROR in OpenSSH: ");
    vsnprintf(buf, sizeof(buf), fmt, args);
	va_end(args);

    printf("%s\n", buf);

}






